/* Cell, rigid: */
class Cell[T](init: T) {
 private var curr = init
 def get = curr
 def set (x: T) = { curr = x }
 }

/* Cell, covariant-- does not compile: 

error: covariant type T occurs in contravariant position in type T of value x
        def set (x: T) = { curr = x }
                 ^
class Cell[+T](init: T) {
 private var curr = init
 def get = curr
 def set (x: T) = { curr = x }
 }
*/

/* Cell, contravariant-- does not compile:

error: contravariant type T occurs in covariant position in type => T of method get
        def get = curr
            ^
class Cell[-T](init: T) {
 private var curr = init
 def get = curr
 def set (x: T) = { curr = x }
 }
*/

/* This would compile but crash with covariant cells
val c1 = new Cell[String]("abc")
val c2 : Cell[Any] = c1
c2.set(1)
val s : String = c1.get
*/
