abstract class Expr
case class Var (name: String) extends Expr
case class Number(num: Double) extends Expr
case class BinOp(op: String, left: Expr, right: Expr) extends Expr

def eval(e: Expr): Double = e match {
  case Number(n) => n
  case BinOp("+", e1, e2) => eval(e1)+ eval(e2)
  case BinOp("*", e1, e2) => eval(e1)* eval(e2)
  case Var(name) => 0
  }
